diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 7a9f1af6c..bc07f6874 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -23,279 +23,299 @@ public class ChunkDecoratorNether
         extends ChunkFeatureDecorator {
     private final @NotNull FractalNoise2D<ImprovedPerlinNoise> crystalDensityNoise;
     private final @NotNull WorleyNoise pillarNoise;
-    private final @NotNull WorleyNoise.Result worleyResult;
+
     public ChunkDecoratorNether(@NotNull World world) {
         super(world);
         this.pillarNoise = new WorleyNoise(new Random(world.getRandomSeed()));
         this.crystalDensityNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 74));
-        this.worleyResult = new WorleyNoise.Result();
+    }
+
+    private TilePos selectPillarPosition(@NotNull Chunk chunk, @NotNull Random random) {
+        int x = chunk.pos.x() * 16 + random.nextInt(16);
+        int z = chunk.pos.z() * 16 + random.nextInt(16);
+        int y = 200;
+
+        WorleyNoise.Result result = new WorleyNoise.Result();
+        this.pillarNoise.getValue(x >> 5, z >> 5, result);
+
+        int xPillar = (int) (result.center.x * 32.0D);
+        int zPillar = (int) (result.center.y * 32.0D);
+
+        return new TilePos(xPillar, y, zPillar);
     }
 
     @Override
     public void registerDecorations() {
-        this.register("minecraft:decoration/nether/default/speleothems",
-            new ChunkDecorationBuilder(new WorldFeatureSpeleothems(12, true, 12, true))
+        // Rubyglass Features
+        this.register("minecraft:decoration/nether/default/rubyglass_crystal_ceiling", (new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystalline(true, 20, 15)))
+            .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST})
+            .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
+            .withPlacementMethod((feature, world, chunk, random) -> {
+                int x = chunk.pos.x * 16;
+                int z = chunk.pos.z * 16;
+                int density = (int) ((this.crystalDensityNoise.getValue((double) x * (double) 0.5F, (double) z * (double) 0.5F) - (double) 6.0F + (double) 30.0F) / (double) 6.0F);
+
+                for (int i = 0; i < density + 4; ++i) {
+                    feature.placeFeature(world, chunk, random);
+                }
+            }));
+
+        this.register("minecraft:decoration/nether/default/rubyglass_crystal_floor", (new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystalline(false, 20, 30)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod((feature, world, chunk, random) -> {
+                    int x = chunk.pos.x * 16;
+                    int z = chunk.pos.z * 16;
+                    int density = (int) ((this.crystalDensityNoise.getValue((double) x * (double) 0.5F, (double) z * (double) 0.5F) - (double) 6.0F + (double) 30.0F) / (double) 6.0F);
+
+                    for (int i = 0; i < density + 4; ++i) {
+                        feature.placeFeature(world, chunk, random);
+                    }
+                }));
+
+        this.register("minecraft:decoration/nether/default/rubyglass_crystal_floor_2", (new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystalline(false, 15, 25)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(4)));
+
+        this.register("minecraft:decoration/nether/default/rubyglass_node", (new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicNodeRubyglass.variantMap, 5)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(10)));
+
+        this.register("minecraft:decoration/nether/default/rubyglass_bud_patch", (new ChunkDecorationBuilder(new WorldFeatureRubyglassGrowthPatch(0.0F)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(100)));
+
+        this.register("minecraft:decoration/nether/default/rubyglass_growth_patch", (new ChunkDecorationBuilder(new WorldFeatureRubyglassGrowthPatch()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(100)));
+
+        // Wall Scatter Features
+        this.register("minecraft:decoration/nether/default/scatter_crystalline", (new ChunkDecorationBuilder(new WorldFeaturePerlinVein(Blocks.COBBLE_NETHERRACK_CRYSTALLINE, Blocks.COBBLE_NETHERRACK, 0.06, 0.045)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST})
+                .withPositionSelector(PositionSelectors.MinY)
+                .withPlacementMethod(PlaceableFeature::placeFeature));
+
+        this.register("minecraft:decoration/nether/default/clump_crystalline", (new ChunkDecorationBuilder(new WorldFeatureWallClump(Blocks.COBBLE_NETHERRACK_CRYSTALLINE, Blocks.COBBLE_NETHERRACK, 1)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(500)));
+
+        this.register("minecraft:decoration/nether/default/clump_brimthaw", (new ChunkDecorationBuilder(new WorldFeatureWallClump(Blocks.BRIMTHAW, Blocks.BRIMSTONE, 1)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(1000)));
+
+        // Water Features
+        this.register("minecraft:decoration/nether/default/water_spring", (new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_WATER_FLOWING.id())))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                .withPositionSelector(PositionSelectors.HeightRangeBiasedTop)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(16)));
+
+        // Lava Features
+        this.register("minecraft:decoration/nether/default/lava_spring", (new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_LAVA_FLOWING.id())))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_CRAG, Biomes.NETHER_SHELF})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(16)));
+
+        this.register("minecraft:decoration/nether/default/lava_spring_2", (new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_LAVA_FLOWING.id())))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(16)));
+
+        this.register("minecraft:decoration/nether/default/lava_lake", (new ChunkDecorationBuilder(new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_CRAG, Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_SHELF, Biomes.NETHER_SULFUR_POOLS})
                 .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
-                .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
-        this.register("minecraft:decoration/nether/default/lava_lake",
-                new ChunkDecorationBuilder(new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()))
-                        .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
-                        .withPlacementMethod(new PlacementMethod.ChanceToPlace(4))
-        );
-        this.register("minecraft:decoration/nether/default/rubyglass_crystal_ceiling",
-                new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystal(true))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST})
-                        .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
-                        .withPlacementMethod(((feature, world, chunk, random) -> {
-                            int x = chunk.pos.x * 16;
-                            int z = chunk.pos.z * 16;
-                            int density = (int) ((this.crystalDensityNoise.getValue(x * 0.5, z * 0.5) - 6D + 30D) / 6D);
-
-                            for (int i = 0; i < density + 4; i++) {
-                                feature.placeFeature(world, chunk, random);
-                            }
-                        }))
-        );
-
-        this.register("minecraft:decoration/nether/default/rubyglass_crystal_floor",
-                new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystal(false, 25, 50))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST})
-                        .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
-                        .withPlacementMethod(((feature, world, chunk, random) -> {
-                            int x = chunk.pos.x * 16;
-                            int z = chunk.pos.z * 16;
-                            int density = (int) ((this.crystalDensityNoise.getValue(x * 0.5, z * 0.5) - 6D + 30D) / 6D);
-
-                            for (int i = 0; i < density + 4; i++) {
-                                feature.placeFeature(world, chunk, random);
-                            }
-                        }))
-        );
-
-        this.register("minecraft:decoration/nether/default/rubyglass_crystal_floor_2",
-                new ChunkDecorationBuilder(new WorldFeatureRubyglassCrystal(false,  20, 30))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
-                        .withPositionSelector(PositionSelectors.UpperHeightRangeUniform)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
-
-        this.register("minecraft:decoration/nether/default/rubyglass_node",
-                new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreRubyglass.variantMap, 5))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
-                        .withPositionSelector(PositionSelectors.HeightRangeUniform)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(10))
-        );
-
-        this.register("minecraft:decoration/nether/default/rubyglass_sprout_patch",
-                new ChunkDecorationBuilder(new WorldFeatureRubyglassSproutPatch())
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(20))
-        );
-
-        this.register("minecraft:decoration/nether/default/nether_water_spring",
-                new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_WATER_FLOWING.id()))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_OLD_WORLD })
-                        .withPositionSelector(PositionSelectors.HeightRangeBiasedTop)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(30))
-        );
-
-        this.register("minecraft:decoration/nether/default/nether_lava_spring",
-                new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_LAVA_FLOWING.id()))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_SULFUR_POOLS, Biomes.NETHER_CRAG, Biomes.NETHER_SHELF })
-                        .withPositionSelector(PositionSelectors.HeightRangeBiasedTop)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(30))
-        );
-
-        this.register("minecraft:decoration/nether/default/nether_lava_spring_2",
-                new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_LAVA_FLOWING.id()))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_VOLCANIC_ISLANDS })
-                        .withPositionSelector(PositionSelectors.HeightRangeBiasedTop)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(20))
-        );
-
-        this.register("minecraft:decoration/nether/default/pillar_netherrack",
-                new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.NETHERRACK.id(), false))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRAG, Biomes.NETHER_SHELF })
-                        .withPositionSelector(((world, chunk, random, minY, maxY, rangeY) -> {
-                            int x = (chunk.pos.x() * 16) + random.nextInt(16);
-                            int z = (chunk.pos.z() * 16) + random.nextInt(16);
-                            int y = 200;
-
-                            double scale = 0.5;
-
-                            this.pillarNoise.getValue(
-                                    Math.floor(x / 32F),
-                                    Math.floor(z / 32F),
-                                this.worleyResult
-                            );
-
-                            int xPillar = (int) (this.worleyResult.center.x * 32);
-                            int zPillar = (int) (this.worleyResult.center.y * 32);
-
-                            return new TilePos(xPillar, y, zPillar);
-                        }))
-                        .withPlacementMethod(new PlacementMethod.ChanceToPlace(4))
-        );
-
-        this.register("minecraft:decoration/nether/default/pillar_cobble_basalt",
-                new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.COBBLE_BASALT.id(), true))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_SULFUR_POOLS, Biomes.NETHER_VOLCANIC_ISLANDS })
-                        .withPositionSelector(((world, chunk, random, minY, maxY, rangeY) -> {
-                            int x = (chunk.pos.x() * 16) + random.nextInt(16);
-                            int z = (chunk.pos.z() * 16) + random.nextInt(16);
-                            int y = 200;
-
-                            double scale = 0.5;
-
-                            this.pillarNoise.getValue(
-                                    Math.floor(x / 32F),
-                                    Math.floor(z / 32F),
-                                this.worleyResult
-                            );
-
-                            int xPillar = (int) (this.worleyResult.center.x * 32);
-                            int zPillar = (int) (this.worleyResult.center.y * 32);
-
-                            return new TilePos(xPillar, y, zPillar);
-                        }))
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
-
-        this.register("minecraft:decoration/nether/default/boulder",
-                new ChunkDecorationBuilder(new WorldFeatureMagmaBoulder())
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_SULFUR_POOLS, Biomes.NETHER_VOLCANIC_ISLANDS })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(2))
-        );
-
-        this.register("minecraft:decoration/nether/default/sulfur_pool_terrace",
-                new ChunkDecorationBuilder(new WorldFeatureTerrace(Blocks.FLUID_WATER_STILL, Blocks.BRIMSAND))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_SULFUR_POOLS })
-                        .withPositionSelector(PositionSelectors.MinY)
-                        .withPlacementMethod(PlacementMethods.OncePerChunk)
-        );
-
-        this.register("minecraft:decoration/nether/default/lava_pool_terrace",
-                new ChunkDecorationBuilder(new WorldFeatureTerrace(Blocks.FLUID_LAVA_STILL, Blocks.COBBLE_BASALT, 4, 4))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_VOLCANIC_ISLANDS })
-                        .withPositionSelector(PositionSelectors.MinY)
-                        .withPlacementMethod(new PlacementMethod.ChanceToPlace(3))
-        );
-
-        this.register("minecraft:decoration/nether/default/sulfur_pool_floor_vent",
-                new ChunkDecorationBuilder(new WorldFeatureFloorVent())
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_SULFUR_POOLS })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(12))
-        );
-
-        this.register("minecraft:decoration/nether/default/sulfur_pool_spire",
-                new ChunkDecorationBuilder(new WorldFeatureThermalSpire())
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_SULFUR_POOLS })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(8))
-        );
-
-        this.register("minecraft:decoration/nether/default/nether_coal_ore",
-                new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreNetherCoal.variantMap, 12))
-                        .withPositionSelector(PositionSelectors.HeightRangeUniform)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(10))
-        );
-
-        this.register("minecraft:decoration/nether/default/nether_coal_ore_2",
-                new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreNetherCoal.variantMap, 12))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_VOLCANIC_ISLANDS })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniform)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(20))
-        );
-
-        this.register("minecraft:decoration/nether/default/glowstone_1",
-                new ChunkDecorationBuilder(new WorldFeatureGlowstone())
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(((feature, world, chunk, random) -> {
-                            int max = random.nextInt(random.nextInt(10) + 1);
-                            for (int i = 0; i < max; i++) {
-                                feature.placeFeature(world, chunk, random);
-                            }
-                        }))
-        );
-
-        this.register("minecraft:decoration/nether/default/glowstone_2",
-                new ChunkDecorationBuilder(new WorldFeatureGlowstone())
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(10))
-        );
-
-        this.register("minecraft:decoration/nether/default/patch_fire_1",
-                new ChunkDecorationBuilder(new WorldFeatureFire())
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
-
-        this.register("minecraft:decoration/nether/default/patch_fire_2",
-                new ChunkDecorationBuilder(new WorldFeatureFire())
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_VOLCANIC_ISLANDS })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
-
-        this.register("minecraft:decoration/nether/default/old_world_patch_bone_pile",
-                new ChunkDecorationBuilder(new WorldFeatureNetherPatch(Blocks.BONE_PILE.id()))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_OLD_WORLD, Biomes.NETHER_OLD_WORLD_DESERT })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
-
-        this.register("minecraft:decoration/nether/default/patch_bone_pile",
-                new ChunkDecorationBuilder(new WorldFeatureNetherPatch(Blocks.BONE_PILE.id()))
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(1))
-        );
-
-        this.register("minecraft:decoration/nether/default/patch_soul_catcher",
-                new ChunkDecorationBuilder(new WorldFeatureNetherPatch(Blocks.SOULCATCHER.id()))
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(2))
-        );
-
-        this.register("minecraft:decoration/nether/default/boneshale_tree",
-                new ChunkDecorationBuilder(((world, random, tilePos) -> {
-                    //todo refactor how spooner trees are instantiated
-                    WorldFeature wf = new WorldFeatureBoneshaleTree(0, Blocks.LOG_PETRIFIED.id());
-                    wf.init(1.0D, 1.0D, 1.0D);
-                    return wf.place(world, random, tilePos);
-                }))
-                        .withBiomeMask(new Biome[]{ Biomes.NETHER_OLD_WORLD })
-                        .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
-                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
-        );
+                .withPlacementMethod(new PlacementMethod.ChanceToPlace(4)));
+
+        this.register("minecraft:decoration/nether/default/lava_pool_terrace", (new ChunkDecorationBuilder(new WorldFeatureTerrace(Blocks.FLUID_LAVA_STILL, Blocks.BRIMSTONE, 4, 4)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.MinY)
+                .withPlacementMethod(new PlacementMethod.ChanceToPlace(3)));
+
+        this.register("minecraft:decoration/nether/default/boulder_magma", (new ChunkDecorationBuilder(new WorldFeatureTerrace(Blocks.FLUID_LAVA_STILL, Blocks.BRIMSTONE, 4, 4)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.MinY)
+                .withPlacementMethod(new PlacementMethod.ChanceToPlace(3)));
+
+        this.register("minecraft:decoration/nether/default/acid_spring", (new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_ACID_FLOWING.id())))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(16)));
+
+        // Pillar Features
+        this.register("minecraft:decoration/nether/default/pillar_netherrack", (new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.RUBYGLASS_COLUMN.id(), false)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST})
+                .withPositionSelector((world, chunk, random, minY, maxY, rangeY) -> selectPillarPosition(chunk, random))
+                .withPlacementMethod(new PlacementMethod.ChanceToPlace(8)));
+
+        this.register("minecraft:decoration/nether/default/pillar_netherrack_2", (new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.COBBLE_NETHERRACK.id(), false)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRAG, Biomes.NETHER_SHELF})
+                .withPositionSelector((world, chunk, random, minY, maxY, rangeY) -> selectPillarPosition(chunk, random))
+                .withPlacementMethod(new PlacementMethod.ChanceToPlace(4)));
+
+        this.register("minecraft:decoration/nether/default/pillar_cobble_basalt", (new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.BRIMSTONE.id(), true)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector((world, chunk, random, minY, maxY, rangeY) -> selectPillarPosition(chunk, random))
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(4)));
+
+        this.register("minecraft:decoration/nether/default/pillar_slate", (new ChunkDecorationBuilder(new WorldFeaturePillar(Blocks.SLATE.id(), true)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_OLD_WORLD})
+                .withPositionSelector((world, chunk, random, minY, maxY, rangeY) -> selectPillarPosition(chunk, random))
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(4)));
+
+        // Nether biome features
+        this.register("minecraft:decoration/nether/default/boulder_magma", new ChunkDecorationBuilder(new WorldFeatureBoulderMagma())
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+
+        this.register("minecraft:decoration/nether/default/sulfur_pool_terrace", new ChunkDecorationBuilder(new WorldFeatureTerrace(Blocks.FLUID_ACID_FLOWING, Blocks.BRIMSAND))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.MinY)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(3)));
+
+        this.register("minecraft:decoration/nether/default/floor_vent", new ChunkDecorationBuilder(new WorldFeatureFloorVent())
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(12)));
+
+        this.register("minecraft:decoration/nether/default/volcanic_islands_spire", new ChunkDecorationBuilder(new WorldFeatureSpireVent())
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(8)));
+
+        this.register("minecraft:decoration/nether/default/sulfur_pool_boulder", new ChunkDecorationBuilder(new WorldFeatureBoulderGlowstone(Blocks.GLOWSTONE, Blocks.FIRE_SULFURIC, 1))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(12)));
+
+        this.register("minecraft:decoration/nether/default/nether_roof_spire", new ChunkDecorationBuilder(new WorldFeatureRoofSpire(Blocks.COBBLE_NETHERRACK))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRAG, Biomes.NETHER_SHELF})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+
+        this.register("minecraft:decoration/nether/default/volcano_roof_spire", new ChunkDecorationBuilder(new WorldFeatureRoofSpire(Blocks.BRIMSTONE))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+
+        this.register("minecraft:decoration/nether/default/sulfur_roof_spire", new ChunkDecorationBuilder(new WorldFeatureRoofSpire(Blocks.SULFUR))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+
+        this.register("minecraft:decoration/nether/default/oldworld_roof_spire", new ChunkDecorationBuilder(new WorldFeatureRoofSpire(Blocks.SLATE))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_OLD_WORLD})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+
+        // Ore Features
+        this.register("minecraft:decoration/nether/default/nether_coal_ore", (new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreNetherCoal.variantMap, 12)))
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(10)));
+
+        this.register("minecraft:decoration/nether/default/nether_coal_ore_2", (new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreNetherCoal.variantMap, 12)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(20)));
+
+        this.register("minecraft:decoration/nether/default/nether_coal_ore_3", (new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreNetherCoal.variantMap, 16)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRAG, Biomes.NETHER_SHELF})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(10)));
+
+        // Glowstone Features
+        this.register("minecraft:decoration/nether/default/glowstone_1", (new ChunkDecorationBuilder(new WorldFeatureGlowstone()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_CRAG, Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_SHELF, Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod((feature, world, chunk, random) -> {
+                    int max = random.nextInt(random.nextInt(10) + 1);
+
+                    for (int i = 0; i < max; ++i) {
+                        feature.placeFeature(world, chunk, random);
+                    }
+                }));
+
+        this.register("minecraft:decoration/nether/default/glowstone_2", (new ChunkDecorationBuilder(new WorldFeatureGlowstone()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS, Biomes.NETHER_CRAG, Biomes.NETHER_CRYSTAL_PLAINS, Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_SHELF, Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(10)));
+
+        this.register("minecraft:decoration/nether/default/glowstone_sulfur", (new ChunkDecorationBuilder(new WorldFeatureGlowstone()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(20)));
+
+        // Fire Features
+        this.register("minecraft:decoration/nether/default/patch_fire", (new ChunkDecorationBuilder(new WorldFeatureFire()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_CRAG, Biomes.NETHER_SHELF})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(16)));
+
+        this.register("minecraft:decoration/nether/default/patch_fire_volcanic", (new ChunkDecorationBuilder(new WorldFeatureFire(Blocks.FIRE, Blocks.NETHERRACK)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_VOLCANIC_ISLANDS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(24)));
+
+        this.register("minecraft:decoration/nether/default/patch_fire_sulfuric", (new ChunkDecorationBuilder(new WorldFeatureFire()))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(32)));
+
+        this.register("minecraft:decoration/nether/default/scatter", (new ChunkDecorationBuilder(new WorldFeatureNetherScatter()))
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(32)));
+
+        this.register("minecraft:decoration/nether/default/patch_soul_catcher", (new ChunkDecorationBuilder(new WorldFeatureSoulCatcherPatch()))
+                .withPositionSelector(PositionSelectors.HeightRangeUniformFromOcean)
+                .withPlacementMethod(new PlacementMethod.TriesPerChunk(2)));
+
+        this.register("minecraft:decoration/nether/default/pebbles", (world, chunk, worldX, worldZ, minY, maxY, rangeY, rand) -> {
+            for (int i = 0; i < 16; ++i) {
+                int xx = worldX + rand.nextInt(16) + 8;
+                int yy = 64 + rand.nextInt(128);
+                int zz = worldZ + rand.nextInt(16) + 8;
+                (new WorldFeaturePebbles(Blocks.OVERLAY_PEBBLES, 16, true)).place(world, rand, xx, yy, zz);
+            }
+        });
+    }
+
+    private static boolean isRubyglassAshSupportForbidden(final @NotNull Block<?> block) {
+        return block == Blocks.RUBYGLASS_NODE
+            || block == Blocks.RUBYGLASS_COLUMN
+            || block == Blocks.RUBYGLASS_GROWTH;
     }
 
     @Override
     public void postDecorate(@NotNull World world, @NotNull Chunk chunk) {
         TilePos queryPose = new TilePos();
-        int oceanY = world.getWorldType().getOceanY();
         int worldX = chunk.pos.x() * 16;
         int worldZ = chunk.pos.z() * 16;
-        int midY = oceanY + (world.getWorldType().getMaxY(world) - oceanY) / 2;
-        for (int dx = worldX; dx < worldX + 16; dx++) {
-            for (int dz = worldZ; dz < worldZ + 16; dz++) {
-                int dy = midY;
-                while (world.isAirBlock(queryPose.set(dx, dy, dz))) {
-                    dy--;
-                }
-                dy++;
-                Biome localBiome = world.getBlockBiome(queryPose.set(dx, dy, dz));
+        int startY = world.getWorldType().getMaxY(world);
 
-                if (localBiome.hasTag(BiomeTags.HAS_SURFACE_ASH) && dy > 0 && dy < world.getHeightBlocks()) {
-                    if (world.isAirBlock(queryPose.set(dx, dy, dz)) && world.getBlockMaterial(queryPose.set(dx, dy - 1, dz)).blocksMotion()) {
-                        world.setBlockType(queryPose.set(dx, dy, dz), Blocks.LAYER_ASH);
+        for (int dx = worldX; dx < worldX + 16; ++dx) {
+            for (int dz = worldZ; dz < worldZ + 16; ++dz) {
+                for (int dy = startY; dy > world.getWorldType().getOceanY(); --dy) {
+                    queryPose.set(dx, dy, dz);
+
+                    if (world.isAirBlock(queryPose)) {
+                        Block<?> blockBelow = world.getBlock(dx, dy - 1, dz);
+
+                        if (blockBelow != Blocks.OBSIDIAN && blockBelow.getMaterial().blocksMotion()
+                                && !isRubyglassAshSupportForbidden(blockBelow)) {
+
+                            Biome localBiome = world.getBlockBiome(queryPose);
+                            if (localBiome.hasTag(BiomeTags.HAS_SURFACE_ASH)) {
+                                world.setBlockType(queryPose, Blocks.LAYER_ASH);
+                            }
+                        }
                     }
                 }
             }
-
         }
     }
 }
